"use strict";

/**
 * Returns a promise that resolves in the given number of milliseconds.
 * @param	{number}	ms	The number of milliseconds to wait before resolving the promise.
 * @return	{Promise}	A Promise that resolves after the given number of milliseconds have passed.
 */
export default function sleep(ms) {
	return new Promise((resolve, _reject) => {
		setTimeout(resolve, ms);
	});
}
